<?php

class fieldImagess extends cmsFormField {

    public $title = "Слайдер изображений [GoodMade]";
    public $sql   = 'text';
	public $allow_index = false;

    public function getOptions(){

		$presets = cmsCore::getModel('images')->getPresetsList();
		$presets['original'] = LANG_PARSER_IMAGE_SIZE_ORIGINAL;

        return array(
		 new fieldList('plugin', array(
                        'title' => 'Используемый Плагин:',
                        'default' => 'fotorama',
                        'items' => array(
                            'fotorama'      => 'Fotorama.io',
                        )
                    )),
            new fieldList('size_teaser', array(
                'title' => LANG_PARSER_IMAGE_SIZE_TEASER,
                'default' => 'small',
                'items' => $presets
            )),
            new fieldList('size_full', array(
                'title' => LANG_PARSER_IMAGE_SIZE_FULL,
                'default' => 'big',
                'items' => $presets
            )),
            new fieldListMultiple('sizes', array(
                'title' => LANG_PARSER_IMAGE_SIZE_UPLOAD,
                'default' => 0,
                'items' => $presets
            )),
			
			
			   new fieldCheckbox('is_overflow_none', array(
                        'title' => 'Расположить слева от текста',
						'hint' => 'Зависит от настроеек ширины контейнера для плагина. Поле с текстом записи должно распологатся следом за этии полем',
                    )),	
			   new fieldNumber('is_overflow_none_lpadd', array(
			     'default' => 20,
                        'hint' => 'Отступ справа, для текста',
                    )),
				new fieldString('is_overflow_none_cfield', array(
			     'default' => 'content',
                        'hint' => 'Системное имя поля с текстом записи, распологающемся следом за этим полем',
                    )),
					
		new fieldList('fotorama_transition', array(
                        'title' => '<h4>Настройки Fotorama.io:</h4><label>Эффект смены изображений</label>',
                        'default' => 'slide',
						 'hint' => 'По вариации: http://fotorama.io/customize/transition/',
                        'items' => array(
                            'slide'      => 'slide',
							   'crossfade'      => 'crossfade',
							    'crossfade'      => 'crossfade',
								 'dissolve'      => 'dissolve',
                        )
                    )),	
		new fieldList('fotorama_transition_mix', array(
                        'title' => '<label>Mix(по щелчку) для эффекта смены изображений</label>',
                        'default' => '',
                        'items' => array(
                            ''      => 'Нет',
							     'slide'      => 'slide',
							   'crossfade'      => 'crossfade',
							    'crossfade'      => 'crossfade',
								 'dissolve'      => 'dissolve',
                        )
                    )),		
			
			      new fieldCheckbox('fotorama_is_hash', array(
                        'title' => 'Использовать Hash',
						'hint' => 'Переход к определённому изображению через якорь в ссылке. Например: http://fotorama.io/examples/hash.html#facing-wind'
                    )),
					   new fieldCheckbox('fotorama_is_shuffle', array(
                        'title' => 'Нумирация изображений',					
						'hint' => 'Например: http://fotorama.io/customize/shuffle/'
                    )),
					  new fieldCheckbox('fotorama_is_keyboard', array(
                        'title' => 'Прокрутка изображений стрелками с клавиатуры',
                    )),
					   new fieldCheckbox('fotorama_is_autoplay', array(
                        'title' => 'Автопрокрутка изображений:',
                    )),					 
					   new fieldNumber('fotorama_autoplay_interval', array(
                        'hint' => 'Интервал для автопрокрутки изображений',
                    )),
					
						   new fieldCheckbox('fotorama_is_trl', array(
                        'title' => 'Прокрутка изображений справа на лево',
						'hint' => 'Например: http://fotorama.io/customize/right-to-left/'
                    )),			
					
				new fieldList('fotorama_nav', array(
                        'title' => 'Навигация',
                        'default' => 'thumbs',
                        'items' => array(
                            ''      => 'Нет',
							     'thumbs'      => 'Превью изображений',
							   'dots'      => 'Точки',
                        )
                    )),		
						new fieldList('fotorama_nav_pos', array(
                        'title' => 'Навигация, расположение',
                        'default' => 'bottom',
                        'items' => array(                
							     'bottom'      => 'Снизу',
							   'top'      => 'Сверху',
                        )
                    )),		
					
							new fieldList('fotorama_fit', array(
                        'title' => 'Подстройка размера изображения',
                        'default' => 'contain',
						'hint' => 'Подробнее: http://fotorama.io/customize/fit/',
                        'items' => array(                
							     'contain'      => 'contain',
							   'cover'      => 'cover',
							      'scaledown'      => 'scaledown',							   
							       'none'      => 'none'
                        )
                    )),	
					
					
					
					new fieldNumber('fotorama_width', array(
                        'title' => 'Ширина',
						 'default' => '700',
						 'hint' => 'data-width, по умолчанию: 700',
                    )),
						new fieldString('fotorama_max_width', array(
                        'title' => 'Макс Ширина',
						 'default' => '100%',
						 'hint' => 'data-max-width, по умолчанию: 100%. Можно задать % или px',
                    )),
						new fieldString('fotorama_ratio', array(
                        'title' => 'Cоотношение сторон',
						 'default' => '700/467',
						 'hint' => 'data-ratio, по умолчанию: 700/467',
                    )),
					
				
        );

    }

    public function parseTeaser($value){

        return $this->parse($value);

    }

    public function parse($value){

        $images = is_array($value) ? $value : cmsModel::yamlToArray($value);

        $html = '';

		$template = cmsTemplate::getInstance();
 
        
	    $tpl_file = $template->getTemplateFileName('assets/fields/imagess/'.$this->getOption('plugin'));
        ob_start();
        include($tpl_file);
        $html = ob_get_clean();

		   
	
        return $html;

    }

    public function store($value, $is_submitted, $old_value=null){

		$config = cmsConfig::getInstance();

		if (!is_array($old_value)){
			$old_value = cmsModel::yamlToArray($old_value);
		}

        foreach($old_value as $image){
            if (!is_array($value) || !in_array($image, $value)){
                foreach($image as $size => $image_url){
                    $image_path = $config->upload_path . $image_url;
                    @unlink($image_path);
                }
            }
        }

        $result = null;

        if (is_array($value)){
            $result = array();
            foreach ($value as $idx=>$paths){ $result[] = $paths; }
        }

        $sizes = $this->getOption('sizes');

        if (empty($sizes) || empty($result)) { return $result; }

        foreach($result as $image){
            foreach($image as $size => $image_url){
                if (!in_array($size, $sizes)){
                    $image_path = $config->upload_path . $image_url;
                    @unlink($image_path);
                }
            }
        }

        return $result;

    }

    public function delete($value){

        if (empty($value)) { return true; }

        if (!is_array($value)){ $value = cmsModel::yamlToArray($value); }

        $config = cmsConfig::getInstance();

        foreach($value as $images){
            foreach($images as $image_url){
                $image_path = $config->upload_path . $image_url;
                @unlink($image_path);
            }
        }

        return true;

    }

    public function getFilterInput($value=false) {

        return html_checkbox($this->name, (bool)$value);

    }

    public function applyFilter($model, $value) {
        return $model->filterNotNull($this->name);
    }

    public function getInput($value){

        $this->data['images'] = false;

        if($value){
            $this->data['images'] = is_array($value) ? $value : cmsModel::yamlToArray($value);
        }

        $this->data['sizes'] = $this->getOption('sizes');

        $this->data['images_controller'] = cmsCore::getController('images');

        return parent::getInput($value);

    }

}
